<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionPerfil }}</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">
        {{ textoGestionPerfil }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            Nombre del Perfil
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="perfil.descripcion"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.perfilVuelidate.descripcion.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(perfil.descripcion, 50)
              "
              background-color="white"
            >
              <template
                v-if="$v.perfilVuelidate.descripcion.$error"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.perfilVuelidate.descripcion.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.perfilVuelidate.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingPerfil },
            { 'error-validation-btn': $v.$invalid }
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="cardPerfil.to"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Perfiles</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionPerfils",
  components: {
    LeavePage
  },
  data() {
    return {
      savingPerfil: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      cardPerfil: {
        to: {
          name: "privilegios_perfiles_configuracion"
        }
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Perfiles",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos"
          }
        }
      ],
      perfilBackup: {
        id_perfil: null,
        descripcion: "",
        fecha_creacion: null,
        escritura: 1,
        id_empleado_crea: null,
        fecha_modificacion: null
      },
      perfil: {
        id_perfil: null,
        descripcion: "",
        fecha_creacion: null,
        escritura: 1,
        id_empleado_crea: null,
        fecha_modificacion: null
      },
      textoGestionPerfil: null
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.perfilBackup) {
        const originalValue = JSON.stringify(this.perfilBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.perfil).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.perfil.id_perfil === undefined;
      }
    },
    perfilVuelidate() {
      let perfilVuelidate = JSON.parse(JSON.stringify(this.perfil));
      return perfilVuelidate;
    }
  },
  validations: {
    perfilVuelidate: {
      descripcion: {
        required
      }
    }
  },
  methods: {
    async guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.perfil.id_empleado_modifica = user.empleado;
        this.perfil.id_empleado = user.empleado;
        this.savingPerfil = true;
        if (this.perfil.id_perfil) {
          axios
            .put("/perfil/secure/put", this.perfil)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.perfilBackup = JSON.parse(JSON.stringify(self.perfil));
                } else {
                  console.log("No Update");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingPerfil = false;
            });
        } else {
          axios
            .post("/perfil/secure/post", this.perfil)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.perfilBackup = JSON.parse(JSON.stringify(self.perfil));
                } else {
                  console.log("No Insert");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingPerfil = false;
            });
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    cancelGlobalChanges() {
      this.perfil = JSON.parse(JSON.stringify(this.perfilBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    initValues() {
      if (!this.perfil.id_perfil) {
        this.textoGestionPerfil = "Crear un Perfil";
        this.breadcrumbs.push({
          text: "Nuevo",
          disabled: true
        });
      } else {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true
        });
        this.textoGestionPerfil = "Editar un Perfil";
      }
    }
  },
  created() {
    if (this.$route.params.perfil) {
      this.perfil = this.serviceCommons.base64ToObject(
        this.$route.params.perfil
      );
      this.perfilBackup = JSON.parse(JSON.stringify(this.perfil));
    }
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
